/*
    Copyright 2011-2013 Regshot Team
    Copyright 2004 tulipfan

    This file is part of Regshot.

    Regshot is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 2.1 of the License, or
    (at your option) any later version.

    Regshot is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with Regshot.  If not, see <http://www.gnu.org/licenses/>.
*/

/* This file orignal coded by tulipfan
   Change function/variable name to more proper ones and fix for x64 by tianwei
*/

#include "global.h"
#include <SetupAPI.h>

// 1.8.2 move definition from global.h to this place
#define MAX_INI_SKIPITEMS 100  // 0..99

// setup based on regshot.ini by tulipfan (tfx)
LPTSTR lpszIniSetup          = TEXT("Setup");
LPTSTR lpszIniFlag           = TEXT("Flag");
LPTSTR lpszIniExtDir         = TEXT("ExtDir");
LPTSTR lpszIniLanguage       = TEXT("Language");
LPTSTR lpszIniOutDir         = TEXT("OutDir");
LPTSTR lpszIniSkipRegKey     = TEXT("SkipRegKey");
LPTSTR lpszIniSkipdir        = TEXT("SkipDir");
LPTSTR lpszIniUseLongRegHead = TEXT("UseLongRegHead");
LPTSTR lpszIniUseRegFormat	 = TEXT("UseRegFormat");	//Paraglider
LPTSTR  lpszIniFullKeyOnSkip = TEXT("UseFullKeyOnSkip");


//LPTSTR lpgrszRegSkipStrings;
//LPTSTR lpgrszFileSkipStrings;

//LPTSTR *lprgszRegSkipStrings;
//LPTSTR *lprgszFileSkipStrings;

BOOL fUseLongRegHead;  // since 1.8.1 tianwei: Flag for compatibility with Regshot 1.61e5 and undoreg 1.46
BOOL fUseRegFormat;    // Paraglider: Flag for using reg file format
BOOL fUseFullKeyOnSkip; // Plag to validate full paths on registry / file skip

BOOL LoadSettingsFromIni(HWND hDlg) // tfx get ini info
{
    //int   i;
    BYTE  nFlag;
    //DWORD cchSection;
    //TCHAR szIniKey[17];

#if 0	
    // Get registry skip strings
    lprgszRegSkipStrings = (LPTSTR*)MYALLOC0((MAX_INI_SKIPITEMS + 1) * sizeof(LPTSTR));
    lprgszRegSkipStrings[MAX_INI_SKIPITEMS] = NULL;  // saftey NULL pointer
    lpgrszRegSkipStrings = (LPTSTR)MYALLOC0(MAX_INI_SECTION_CHARS * sizeof(TCHAR));
    cchSection = GetPrivateProfileSection(lpszIniSkipRegKey, lpgrszRegSkipStrings, MAX_INI_SECTION_CHARS, lpszRegshotIni);  // length incl. double NULL character
    if (0 < cchSection) {
        for (i = 0; MAX_INI_SKIPITEMS > i; i++) {
            _sntprintf(szIniKey, 17, TEXT("%d%s\0"), i, TEXT("="));
            szIniKey[16] = (TCHAR)'\0';  // saftey NULL char
            lprgszRegSkipStrings[i] = FindKeyInIniSection(lpgrszRegSkipStrings, szIniKey, cchSection, _tcslen(szIniKey));
            if (NULL == lprgszRegSkipStrings[i]) {
                break;  // not found, so do not look any further
            }
        }
    }

    // Get file skip strings
    lprgszFileSkipStrings = (LPTSTR*)MYALLOC0((MAX_INI_SKIPITEMS + 1) * sizeof(LPTSTR));
    lprgszFileSkipStrings[MAX_INI_SKIPITEMS] = NULL;  // saftey NULL pointer
    lpgrszFileSkipStrings = (LPTSTR)MYALLOC0(MAX_INI_SECTION_CHARS * sizeof(TCHAR));
    cchSection = GetPrivateProfileSection(lpszIniSkipdir, lpgrszFileSkipStrings, MAX_INI_SECTION_CHARS, lpszRegshotIni);  // length incl. double NULL character
    if (0 < cchSection) {
        for (i = 0; MAX_INI_SKIPITEMS > i; i++) {
            _sntprintf(szIniKey, 17, TEXT("%d%s\0"), i, TEXT("="));
            szIniKey[16] = (TCHAR)'\0';  // saftey NULL char
            lprgszFileSkipStrings[i] = FindKeyInIniSection(lpgrszFileSkipStrings, szIniKey, cchSection, _tcslen(szIniKey));
            if (NULL == lprgszFileSkipStrings[i]) {
                break;  // not found, so do not look any further
            }
        }
    }
#endif

	SkipRegValuesCount = GetSkipSection(lpszRegshotIni,lpszIniSkipRegKey, &SkipRegValues);
	SkipDirValuesCount = GetSkipSection(lpszRegshotIni, lpszIniSkipdir, &SkipDirValues);

    // Flags
    nFlag = (BYTE)GetPrivateProfileInt(lpszIniSetup, lpszIniFlag, 1, lpszRegshotIni); // default from 0 to 1 in 1.8.2 (TEXT)
    /*if (nFlag != 0) {  // deleted in 1.8.1 */
    SendMessage(GetDlgItem(hDlg, IDC_RADIO1), BM_SETCHECK, (WPARAM)(nFlag & 0x01), (LPARAM)0);  // Text output
    SendMessage(GetDlgItem(hDlg, IDC_RADIO2), BM_SETCHECK, (WPARAM)((nFlag & 0x01) ^ 0x01), (LPARAM)0);  // HTML output
    //SendMessage(GetDlgItem(hDlg, IDC_CHECKDIR), BM_SETCHECK, (WPARAM)((nFlag&0x04)>>1), (LPARAM)0); // 1.7
    SendMessage(GetDlgItem(hDlg, IDC_CHECKDIR), BM_SETCHECK, (WPARAM)((nFlag & 0x02) >> 1), (LPARAM)0);
    /*} else {  // deleted in 1.8.1
        SendMessage(GetDlgItem(hDlg, IDC_RADIO1), BM_SETCHECK, (WPARAM)0x01, (LPARAM)0);
        SendMessage(GetDlgItem(hDlg, IDC_RADIO2), BM_SETCHECK, (WPARAM)0x00, (LPARAM)0);
        SendMessage(GetDlgItem(hDlg, IDC_CHECKDIR), BM_SETCHECK, (WPARAM)0x00, (LPARAM)0);
    }
    */

    // UseLongRegHead
    fUseLongRegHead = GetPrivateProfileInt(lpszIniSetup, lpszIniUseLongRegHead, 0, lpszRegshotIni) != 0 ? TRUE : FALSE;

	// Paraglider
	fUseRegFormat=GetPrivateProfileInt(lpszIniSetup, lpszIniUseRegFormat, 0, lpszRegshotIni)!=0 ? TRUE:FALSE;
	if (!fUseRegFormat)
	{
		CreateNewResult = CreateNewResultOrg;
	}
	else
	{
		fUseLongRegHead = 1;
		CreateNewResult = CreateNewResultReg;
	}

	fUseFullKeyOnSkip = GetPrivateProfileInt(lpszIniSetup, lpszIniFullKeyOnSkip, 0, lpszRegshotIni)!=0 ? TRUE:FALSE;
	
	// End Paraglider

    // Scan Dirs
    if (0 != GetPrivateProfileString(lpszIniSetup, lpszIniExtDir, NULL, lpszExtDir, MAX_PATH, lpszRegshotIni)) {  // length incl. NULL character
        SetDlgItemText(hDlg, IDC_EDITDIR, lpszExtDir);
    } else {
        SetDlgItemText(hDlg, IDC_EDITDIR, lpszWindowsDirName);
    }

    // Output Dir
    if (0 != GetPrivateProfileString(lpszIniSetup, lpszIniOutDir, NULL, lpszOutputPath, MAX_PATH, lpszRegshotIni)) {  // length incl. NULL character
        SetDlgItemText(hDlg, IDC_EDITPATH, lpszOutputPath);
    } else {
        SetDlgItemText(hDlg, IDC_EDITPATH, lpszTempPath);
    }

    SendMessage(hDlg, WM_COMMAND, (WPARAM)IDC_CHECKDIR, (LPARAM)0);

    return TRUE;
}


BOOL SaveSettingsToIni(HWND hDlg) // tfx save settings to ini
{
    BYTE    nFlag;
    LPTSTR  lpszValue;
    HANDLE  hTest;

    // 1.8.2, someone might not want to create a regshot.ini when there isn't one. :O
    hTest = CreateFile(lpszRegshotIni, GENERIC_READ | GENERIC_WRITE,
                       FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
    if (hTest == INVALID_HANDLE_VALUE) {
        return FALSE;
    }
    CloseHandle(hTest);

    //nFlag = (BYTE)(SendMessage(GetDlgItem(hDlg, IDC_RADIO1), BM_GETCHECK, (WPARAM)0, (LPARAM)0) // 1.7
    //  |SendMessage(GetDlgItem(hDlg, IDC_RADIO2), BM_GETCHECK, (WPARAM)0, (LPARAM)0)<<1
    //  |SendMessage(GetDlgItem(hDlg, IDC_CHECKDIR), BM_GETCHECK, (WPARAM)0, (LPARAM)0)<<2);
    nFlag = (BYTE)(SendMessage(GetDlgItem(hDlg, IDC_RADIO1), BM_GETCHECK, (WPARAM)0, (LPARAM)0) |
                   SendMessage(GetDlgItem(hDlg, IDC_CHECKDIR), BM_GETCHECK, (WPARAM)0, (LPARAM)0) << 1);

    lpszValue = (LPTSTR)MYALLOC0(EXTDIRLEN * sizeof(TCHAR));  // EXTDIRLEN due to IDC_EDITDIR
    //_sntprintf(lpszValue, EXTDIRLEN, TEXT("%s = %d\0"), lpszIniFlag, nFlag);                   // 1.7 solokey
    //lpszValue[EXTDIRLEN - 1] = (TCHAR)'\0';  // safety NULL char
    //WritePrivateProfileSection(lpszIniSetup, lpszValue, lpszRegshotIni);  // 1.7 solokey, can only have one key.

    // 1.8.1
    _sntprintf(lpszValue, EXTDIRLEN, TEXT("%d\0"), nFlag);
    lpszValue[EXTDIRLEN - 1] = (TCHAR)'\0';  // safety NULL char
    WritePrivateProfileString(lpszIniSetup, lpszIniFlag, lpszValue, lpszRegshotIni);

    _sntprintf(lpszValue, EXTDIRLEN, TEXT("%d\0"), fUseLongRegHead);
    lpszValue[EXTDIRLEN - 1] = (TCHAR)'\0';  // safety NULL char
    WritePrivateProfileString(lpszIniSetup, lpszIniUseLongRegHead, lpszValue, lpszRegshotIni);

	// Paraglider
	_sntprintf(lpszValue, EXTDIRLEN, TEXT("%d"), fUseRegFormat);
	WritePrivateProfileString(lpszIniSetup, lpszIniUseRegFormat, lpszValue, lpszRegshotIni);
	_sntprintf(lpszValue, EXTDIRLEN, TEXT("%d"), fUseFullKeyOnSkip);
	WritePrivateProfileString(lpszIniSetup, lpszIniFullKeyOnSkip, lpszValue, lpszRegshotIni);
	// End Paraglider


    if (GetDlgItemText(hDlg, IDC_EDITDIR, lpszValue, EXTDIRLEN) != 0) {  // length incl. NULL character
        lpszValue[EXTDIRLEN - 1] = (TCHAR)'\0';  // safety NULL char
        WritePrivateProfileString(lpszIniSetup, lpszIniExtDir, lpszValue, lpszRegshotIni);
    }

    if (GetDlgItemText(hDlg, IDC_EDITPATH, lpszValue, EXTDIRLEN) != 0) {  // length incl. NULL character
        lpszValue[EXTDIRLEN - 1] = (TCHAR)'\0';  // safety NULL char
        WritePrivateProfileString(lpszIniSetup, lpszIniOutDir, lpszValue, lpszRegshotIni);
    }

    // 1.9.0: Write language selection to regshot ini (was in language ini before)
    WritePrivateProfileString(lpszIniSetup, lpszIniLanguage, lpszLanguage, lpszRegshotIni);

    MYFREE(lpszValue);

    /* Clean up global memory and from LoadSettingsFromIni() plus SetTextsToSelectedLanguage()*/
    MYFREE(lpszRegshotIni);
    //if (NULL != lpgrszRegSkipStrings) {
    //    MYFREE(lpgrszRegSkipStrings);
    //}
    //if (NULL != lpgrszFileSkipStrings) {
    //    MYFREE(lpgrszFileSkipStrings);
    //}
    if (NULL != lpgrszLangSection) {
        MYFREE(lpgrszLangSection);
    }

    return TRUE;
}

//BOOL IsInSkipList(LPTSTR lpszString, LPTSTR rgszSkipList[])  // tfx skip the list
//{
//
//    for (i = 0; (MAX_INI_SKIPITEMS > i) && (NULL != rgszSkipList[i]); i++) {
//        if (0 == _tcsicmp(lpszString, rgszSkipList[i])) {
//            return TRUE;
//        }
//    }
//    return FALSE;
//}

// PG

int GetSkipSection(TCHAR * iniFile, TCHAR * section, VALUES ** values)
{
	int MaxCount = MAX_VALUES;
	int MaxSize = 4096;
	INFCONTEXT context;
	DWORD ret;
	int idx;

	HINF inf = SetupOpenInfFile(iniFile,NULL, INF_STYLE_OLDNT, NULL);
	if (inf == INVALID_HANDLE_VALUE) return 0;

	ret = SetupFindFirstLine(inf, section,NULL,&context);
	idx = 0;
	if (ret != 0)
	{
		VALUES * Values = (VALUES*)MYALLOC(4096);
		do
		{
			DWORD size = 0;
			LPTSTR line;
			ret = SetupGetLineText(&context, inf, NULL, NULL, NULL, 0, &size);
			line = (LPTSTR)MYALLOC(size * sizeof(TCHAR));
			ret = SetupGetLineText(&context, inf, NULL, NULL, line, size, &size);
			if (ret != 0)
			{
				VALUES * current = &Values[idx];
				TCHAR * keyname;

				current->fullValue = NULL;
				keyname = _tcsrchr(line,_T('\\'));
				if (NULL != keyname)
				{
					current->finalValue = keyname+1;
					current->fullValue = line;
					*keyname = 0;
				}
				else
				{
					current->finalValue = line;
					current->fullValue = NULL;
				}
				++idx;
				if (idx == MaxCount)
				{
					MaxSize += 4096;
					MaxCount += MAX_VALUES;
					Values = (VALUES*)MYREALLOC(MaxSize, Values);
				}
			}
			ret = SetupFindNextLine(&context, &context);
		}
		while (ret != 0);
		*values = Values;
	}
	SetupCloseInfFile(inf);
	return idx;
}

BOOL IsInSkipList(LPTSTR lpStr, LPKEYCONTENT lpKeyContent)  
{
	DWORD i;
	LPTSTR lpFull;

    for (i = 0; i < SkipRegValuesCount; i++) {
		VALUES * pSkipItem = &SkipRegValues[i];
        if (_tcsicmp(lpStr, (const TCHAR*)pSkipItem->finalValue) == 0) 
		{
			if (pSkipItem->fullValue == NULL) return TRUE;
			lpFull = GetWholeKeyName(lpKeyContent->lpFatherKC, fUseLongRegHead);
			if (_tcsicmp(pSkipItem->fullValue, lpFull) == 0)
			{
				MYFREE(lpFull);
				return TRUE;
			}
			MYFREE(lpFull);
        }
    }
    return FALSE;
}

BOOL IsInSkipList2(LPTSTR lpStr, LPTSTR lpFullKey)  
{
	DWORD i;
    for (i = 0; i < SkipDirValuesCount; i++) {
		VALUES * pSkipItem = &SkipDirValues[i];
        if (_tcsicmp(lpStr, (const TCHAR*)pSkipItem->finalValue) == 0 && 
			( pSkipItem->fullValue == NULL || _tcsicmp(lpFullKey, pSkipItem->fullValue) == 0)) {
            return TRUE;
        }
    }
    return FALSE;
}

